function c=sum(a,dim)
  % A : N-by-m-by-n amat
  % c=sum(a) : c m-by-n matrix, sum of all the N matrices
  % c=sum(a,1) : c: N-by-1-by-n amat, sum of each matrices along dim=1 (rows)
  % c=sum(a,2) : c: N-by-m-by-1 amat, sum of each matrices along dim=2 (columns)
  if nargin==1
    c=reshape(sum(a.values,1),[a.nr,a.nc]);
    return
  end
  assert( ismember(dim,1:2) )
  if isempty(a)
    if dim==1
      c=amat(a.N,1,max(1,a.nc),class(a.values));
    else
      c=amat(a.N,max(1,a.nr),1,class(a.values));
    end
    return
  end
  
  if a.ns==3
    c=amat(sum(a.values,dim+1),class(a.values));
  else
    if dim==1
      c=amat(sum(a.values,2),class(a.values));
    else
      c=a;
    end
  end
end
  
